wxWidgets: wxPGProperty Class Reference

| Version: 3.0.2

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | List of all members
wxPGProperty Class Reference
wxPropertyGrid

`#include <wx/propgrid/property.h>`

Inheritance diagram for wxPGProperty:
[legend]

## Detailed Description

wxPGProperty is base class for all wxPropertyGrid properties.

In sections below we cover few related topics.

- Supplied Ready-to-use Property Classes
- Creating Custom Properties

# Supplied Ready-to-use Property Classes

Here is a list and short description of supplied fully-functional property classes. They are located in either props.h or advprops.h.

- wxArrayStringProperty
- wxBoolProperty
- wxColourProperty
- wxCursorProperty
- wxDateProperty
- wxDirProperty
- wxEditEnumProperty
- wxEnumProperty
- wxFileProperty
- wxFlagsProperty
- wxFloatProperty
- wxFontProperty
- wxImageFileProperty
- wxIntProperty
- wxLongStringProperty
- wxMultiChoiceProperty
- wxPropertyCategory
- wxStringProperty
- wxSystemColourProperty
- wxUIntProperty

## wxPropertyCategory

Not an actual property per se, but a header for a group of properties. Regardless inherits from wxPGProperty, and supports displaying 'labels' for columns other than the first one. Easiest way to set category's label for second column is to call wxPGProperty::SetValue() with string argument.

## wxStringProperty

Simple string property. wxPG_STRING_PASSWORD attribute may be used to echo value as asterisks and use wxTE_PASSWORD for wxTextCtrl. wxPG_ATTR_AUTOCOMPLETE attribute may be used to enable auto-completion (use a wxArrayString value), and is also supported by any property that happens to use a wxTextCtrl-based editor.

Remarks
  wxStringProperty has a special trait: if it has value of "<composed>", and also has child properties, then its displayed value becomes composition of child property values, similar as with wxFontProperty, for instance.

## wxIntProperty

Like wxStringProperty, but converts text to a signed long integer. wxIntProperty seamlessly supports 64-bit integers (ie. wxLongLong). To safely convert variant to integer, use code like this:

wxLongLong ll;
ll << property->GetValue();
// or
wxLongLong ll = propertyGrid->GetPropertyValueAsLong(property);

## wxUIntProperty

Like wxIntProperty, but displays value as unsigned int. To set the prefix used globally, manipulate wxPG_UINT_PREFIX string attribute. To set the globally used base, manipulate wxPG_UINT_BASE int attribute. Regardless of current prefix, understands (hex) values starting with both "0x" and "$". Like wxIntProperty, wxUIntProperty seamlessly supports 64-bit unsigned integers (ie. wxULongLong). Same wxVariant safety rules apply.

## wxFloatProperty

Like wxStringProperty, but converts text to a double-precision floating point. Default float-to-text precision is 6 decimals, but this can be changed by modifying wxPG_FLOAT_PRECISION attribute.

Note that when displaying the value, sign is omitted if the resulting textual representation is effectively zero (for example, -0.0001 with precision of 3 will become 0.0 instead of -0.0). This behaviour is unlike what C standard library does, but should result in better end-user experience in almost all cases.

## wxBoolProperty

Represents a boolean value. wxChoice is used as editor control, by the default. wxPG_BOOL_USE_CHECKBOX attribute can be set to true in order to use check box instead.

## wxLongStringProperty

Like wxStringProperty, but has a button that triggers a small text editor dialog. Note that in long string values, tabs are represented by "\t" and line break by "\n".

To display custom dialog on button press, you can subclass wxLongStringProperty and implement OnButtonClick, like this:

virtual bool OnButtonClick( wxPropertyGrid* propGrid, wxString& value )
{
wxSize dialogSize(...size of your dialog...);
wxPoint dlgPos = propGrid->GetGoodEditorDialogPosition(this,
dialogSize)
// Create dialog dlg at dlgPos. Use value as initial string
// value.
...
if ( dlg.ShowModal() == wxID_OK )
{
value = dlg.GetStringValue);
return true;
}
return false;
}

Also, if you wish not to have line breaks and tabs translated to escape sequences, then do following in constructor of your subclass:

m_flags |= wxPG_PROP_NO_ESCAPE;

## wxDirProperty

Like wxLongStringProperty, but the button triggers dir selector instead. Supported properties (all with string value): wxPG_DIR_DIALOG_MESSAGE.

## wxFileProperty

Like wxLongStringProperty, but the button triggers file selector instead. Default wildcard is "All files..." but this can be changed by setting wxPG_FILE_WILDCARD attribute (see wxFileDialog for format details). Attribute wxPG_FILE_SHOW_FULL_PATH can be set to false in order to show only the filename, not the entire path.

## wxEnumProperty

Represents a single selection from a list of choices - wxOwnerDrawnComboBox is used to edit the value.

## wxFlagsProperty

Represents a bit set that fits in a long integer. wxBoolProperty sub- properties are created for editing individual bits. Textctrl is created to manually edit the flags as a text; a continuous sequence of spaces, commas and semicolons are considered as a flag id separator.

Note: When changing "choices" (ie. flag labels) of wxFlagsProperty, you will need to use wxPGProperty::SetChoices() - otherwise they will not get updated properly.

wxFlagsProperty supports the same attributes as wxBoolProperty.

## wxArrayStringProperty

Allows editing of a list of strings in wxTextCtrl and in a separate dialog. Supports "Delimiter" attribute, which defaults to comma (',').

## wxDateProperty

wxDateTime property. Default editor is DatePickerCtrl, although TextCtrl should work as well. wxPG_DATE_FORMAT attribute can be used to change string wxDateTime::Format uses (although default is recommended as it is locale-dependent), and wxPG_DATE_PICKER_STYLE allows changing window style given to DatePickerCtrl (default is wxDP_DEFAULT|wxDP_SHOWCENTURY). Using wxDP_ALLOWNONE will enable better unspecified value support.

## wxEditEnumProperty

Represents a string that can be freely edited or selected from list of choices - custom combobox control is used to edit the value.

## wxMultiChoiceProperty

Allows editing a multiple selection from a list of strings. This is property is pretty much built around concept of wxMultiChoiceDialog. It uses wxArrayString value.

## wxImageFileProperty

Like wxFileProperty, but has thumbnail of the image in front of the filename and autogenerates wildcard from available image handlers.

## wxColourProperty

Useful alternate editor: Choice.

Represents wxColour. wxButton is used to trigger a colour picker dialog. There are various sub-classing opportunities with this class. See below in wxSystemColourProperty section for details.

Setting "HasAlpha" attribute to true for this property allows user to edit the alpha colour component.

## wxFontProperty

Represents wxFont. Various sub-properties are used to edit individual subvalues.

## wxSystemColourProperty

Represents wxColour and a system colour index. wxChoice is used to edit the value. Drop-down list has color images. Note that value type is wxColourPropertyValue instead of wxColour (which wxColourProperty uses).

class wxColourPropertyValue : public wxObject
{
public:
// An integer value relating to the colour, and which exact
// meaning depends on the property with which it is used.
//
// For wxSystemColourProperty:
// Any of wxSYS_COLOUR_XXX, or any web-colour ( use wxPG_TO_WEB_COLOUR
// macro - (currently unsupported) ), or wxPG_COLOUR_CUSTOM.
wxUint32 m_type;
// Resulting colour. Should be correct regardless of type.
wxColour m_colour;
};

in wxSystemColourProperty, and its derived class wxColourProperty, there are various sub-classing features. To set a basic list of colour names, call wxPGProperty::SetChoices().

// Override in derived class to customize how colours are translated
// to strings.
virtual wxString ColourToString( const wxColour& col, int index ) const;
// Returns index of entry that triggers colour picker dialog
// (default is last).
virtual int GetCustomColourIndex() const;
// Helper function to show the colour dialog
bool QueryColourFromUser( wxVariant& variant ) const;
// Returns colour for given choice.
// Default function returns wxSystemSettings::GetColour(index).
virtual wxColour GetColour( int index ) const;

## wxCursorProperty

Represents a wxCursor. wxChoice is used to edit the value. Drop-down list has cursor images under some (wxMSW) platforms.

# Creating Custom Properties

New properties can be created by subclassing wxPGProperty or one of the provided property classes, and (re)implementing necessary member functions. Below, each virtual member function has ample documentation about its purpose and any odd details which to keep in mind.

Here is a very simple 'template' code:

class MyProperty : public wxPGProperty
{
public:
// Default constructor
MyProperty() { }
// All arguments of this ctor must have a default value -
// use wxPG_LABEL for label and name
MyProperty( const wxString& label = wxPG_LABEL,
const wxString& name = wxPG_LABEL,
const wxString& value = wxEmptyString )
: wxPGProperty(label, name)
{
// m_value is wxVariant
m_value = value;
}
virtual ~MyProperty() { }
const wxPGEditor* DoGetEditorClass() const
{
// Determines editor used by property.
// You can replace 'TextCtrl' below with any of these
// builtin-in property editor identifiers: Choice, ComboBox,
// TextCtrlAndButton, ChoiceAndButton, CheckBox, SpinCtrl,
// DatePickerCtrl.
return wxPGEditor_TextCtrl;
}
virtual wxString ValueToString( wxVariant& value,
int argFlags ) const
{
// TODO: Convert given property value to a string
}
virtual bool StringToValue( wxVariant& variant, const wxString& text, int argFlags )
{
// TODO: Adapt string to property value.
}
protected:
};

Since wxPGProperty derives from wxObject, you can use standard wxDECLARE_DYNAMIC_CLASS and wxIMPLEMENT_DYNAMIC_CLASS macros. From the above example they were omitted for sake of simplicity, and besides, they are only really needed if you need to use wxRTTI with your property class.

You can change the 'value type' of a property by simply assigning different type of variant with SetValue. It is mandatory to implement wxVariantData class for all data types used as property values. You can use macros declared in wxPropertyGrid headers. For instance:

// In header file:
// (If you need to have export declaration, use version of macros
// with _EXPORTED postfix)
WX_PG_DECLARE_VARIANT_DATA(MyDataClass)
// In sources file:
WX_PG_IMPLEMENT_VARIANT_DATA(MyDataClass)
// Or, if you don't have valid == operator:
WX_PG_IMPLEMENT_VARIANT_DATA_DUMMY_EQ(MyDataClass)

##

Library: wxPropertyGrid
Category: wxPropertyGrid

## Public Types
typedef wxUint32 | FlagType

## Public Member Functions
| wxPGProperty ()
| Default constructor.
| wxPGProperty (const wxString &label, const wxString &name)
| Constructor.
virtual | ~wxPGProperty ()
| Virtual destructor.
virtual void | OnSetValue ()
| This virtual function is called after m_value has been set.
virtual wxVariant | DoGetValue () const
| Override this to return something else than m_value as the value.
virtual bool | ValidateValue (wxVariant &value, wxPGValidationInfo &validationInfo) const
| Implement this function in derived class to check the value.
virtual bool | StringToValue (wxVariant &variant, const wxString &text, int argFlags=0) const
| Converts text into wxVariant value appropriate for this property.
virtual bool | IntToValue (wxVariant &variant, int number, int argFlags=0) const
| Converts integer (possibly a choice selection) into wxVariant value appropriate for this property.
virtual wxString | ValueToString (wxVariant &value, int argFlags=0) const
| Converts property value into a text representation.
bool | SetValueFromString (const wxString &text, int flags=0)
| Converts string to a value, and if successful, calls SetValue() on it.
bool | SetValueFromInt (long value, int flags=0)
| Converts integer to a value, and if successful, calls SetValue() on it.
virtual wxSize | OnMeasureImage (int item=-1) const
| Returns size of the custom painted image in front of property.
virtual bool | OnEvent (wxPropertyGrid *propgrid, wxWindow *wnd_primary, wxEvent &event)
| Events received by editor widgets are processed here.
virtual wxVariant | ChildChanged (wxVariant &thisValue, int childIndex, wxVariant &childValue) const
| Called after value of a child property has been altered.
virtual const wxPGEditor * | DoGetEditorClass () const
| Returns pointer to an instance of used editor.
virtual wxValidator * | DoGetValidator () const
| Returns pointer to the wxValidator that should be used with the editor of this property (NULL for no validator).
virtual void | OnCustomPaint (wxDC &dc, const wxRect &rect, wxPGPaintData &paintdata)
| Override to paint an image in front of the property value text or drop-down list item (but only if wxPGProperty::OnMeasureImage is overridden as well).
virtual wxPGCellRenderer * | GetCellRenderer (int column) const
| Returns used wxPGCellRenderer instance for given property column (label=0, value=1).
virtual int | GetChoiceSelection () const
| Returns which choice is currently selected.
virtual void | RefreshChildren ()
| Refresh values of child properties.
virtual bool | DoSetAttribute (const wxString &name, wxVariant &value)
| Reimplement this member function to add special handling for attributes of this property.
virtual wxVariant | DoGetAttribute (const wxString &name) const
| Returns value of an attribute.
virtual wxPGEditorDialogAdapter * | GetEditorDialog () const
| Returns instance of a new wxPGEditorDialogAdapter instance, which is used when user presses the (optional) button next to the editor control;.
virtual void | OnValidationFailure (wxVariant &pendingValue)
| Called whenever validation has failed with given pending value.
int | AddChoice (const wxString &label, int value=wxPG_INVALID_VALUE)
| Append a new choice to property's list of choices.
| wxDEPRECATED (void AddChild(wxPGProperty *prop))
| Adds a private child property.
void | AddPrivateChild (wxPGProperty *prop)
| Adds a private child property.
void | AdaptListToValue (wxVariant &list, wxVariant *value) const
| Adapts list variant into proper value using consecutive ChildChanged() calls.
wxPGProperty * | AppendChild (wxPGProperty *childProperty)
| Use this member function to add independent (ie.
bool | AreAllChildrenSpecified (wxVariant *pendingList=NULL) const
| Determines, recursively, if all children are not unspecified.
bool | AreChildrenComponents () const
| Returns true if children of this property are component values (for instance, points size, face name, and is_underlined are component values of a font).
void | ChangeFlag (wxPGPropertyFlags flag, bool set)
| Sets or clears given property flag.
void | DeleteChildren ()
| Deletes children of the property.
void | DeleteChoice (int index)
| Removes entry from property's wxPGChoices and editor control (if it is active).
void | Enable (bool enable=true)
| Enables or disables the property.
wxString | GenerateComposedValue () const
| Composes text from values of child properties.
wxVariant | GetAttribute (const wxString &name) const
| Returns property attribute value, null variant if not found.
wxString | GetAttribute (const wxString &name, const wxString &defVal) const
| Returns named attribute, as string, if found.
long | GetAttributeAsLong (const wxString &name, long defVal) const
| Returns named attribute, as long, if found.
double | GetAttributeAsDouble (const wxString &name, double defVal) const
| Returns named attribute, as double, if found.
wxVariant | GetAttributesAsList () const
| Returns attributes as list wxVariant.
const wxPGEditor * | GetColumnEditor (int column) const
| Returns editor used for given column.
const wxString & | GetBaseName () const
| Returns property's base name (ie.
const wxPGCell & | GetCell (unsigned int column) const
| Returns wxPGCell of given column.
wxPGCell & | GetCell (unsigned int column)
| Returns wxPGCell of given column, creating one if necessary.
wxPGCell & | GetOrCreateCell (unsigned int column)
| Returns wxPGCell of given column, creating one if necessary.
unsigned int | GetChildCount () const
| Returns number of child properties.
int | GetChildrenHeight (int lh, int iMax=-1) const
| Returns height of children, recursively, and by taking expanded/collapsed status into account.
const wxPGChoices & | GetChoices () const
| Returns read-only reference to property's list of choices.
void * | GetClientData () const
| Returns client data (void*) of a property.
wxClientData * | GetClientObject () const
| Sets managed client object of a property.
wxVariant | GetDefaultValue () const
| Returns property's default value.
wxString | GetDisplayedString () const
| Returns property's displayed text.
const wxPGEditor * | GetEditorClass () const
| Returns wxPGEditor that will be used and created when property becomes selected.
FlagType | GetFlags () const
| Returns property flags.
wxPropertyGrid * | GetGrid () const
| Returns property grid where property lies.
wxPropertyGrid * | GetGridIfDisplayed () const
| Returns owner wxPropertyGrid, but only if one is currently on a page displaying this property.
const wxString & | GetHelpString () const
| Returns property's help or description text.
unsigned int | GetIndexInParent () const
| Returns position in parent's array.
const wxString & | GetLabel () const
| Returns property's label.
const wxPGProperty * | GetLastVisibleSubItem () const
| Returns last visible child property, recursively.
wxPGProperty * | GetMainParent () const
| Returns highest level non-category, non-root parent.
int | GetMaxLength () const
| Returns maximum allowed length of property's text value.
wxString | GetName () const
| Returns property's name with all (non-category, non-root) parents.
wxPGProperty * | GetParent () const
| Return parent of property.
wxPGProperty * | GetPropertyByName (const wxString &name) const
| Returns (direct) child property with given name (or NULL if not found).
wxValidator * | GetValidator () const
| Gets assignable version of property's validator.
wxVariant | GetValue () const
| Returns property's value.
wxBitmap * | GetValueImage () const
| Returns bitmap that appears next to value text.
virtual wxString | GetValueAsString (int argFlags=0) const
| Returns text representation of property's value.
| wxDEPRECATED (wxString GetValueString(int argFlags=0) const )
| Synonymous to GetValueAsString().
wxString | GetValueType () const
| Returns value type used by this property.
int | GetY () const
| Returns coordinate to the top y of the property.
FlagType | HasFlag (wxPGPropertyFlags flag) const
| Returns non-zero if property has given flag set.
bool | HasVisibleChildren () const
| Returns true if property has even one visible child.
bool | Hide (bool hide, int flags=wxPG_RECURSE)
| Hides or reveals the property.
int | Index (const wxPGProperty *p) const
| Returns index of given child property.
wxPGProperty * | InsertChild (int index, wxPGProperty *childProperty)
| Use this member function to add independent (ie.
int | InsertChoice (const wxString &label, int index, int value=wxPG_INVALID_VALUE)
| Inserts a new choice to property's list of choices.
bool | IsCategory () const
| Returns true if this property is actually a wxPropertyCategory.
bool | IsEnabled () const
| Returns true if property is enabled.
bool | IsExpanded () const
| Returns true if property has visible children.
bool | IsRoot () const
| Returns true if this property is actually a wxRootProperty.
bool | IsSomeParent (wxPGProperty *candidateParent) const
| Returns true if candidateParent is some parent of this property.
bool | IsTextEditable () const
| Returns true if property has editable wxTextCtrl when selected.
bool | IsValueUnspecified () const
| Returns true if property's value is considered unspecified.
bool | IsVisible () const
| Returns true if all parents expanded.
wxPGProperty * | Item (unsigned int i) const
| Returns child property at index i.
void | RefreshEditor ()
| If property's editor is active, then update it's value.
void | SetAttribute (const wxString &name, wxVariant value)
| Sets an attribute for this property.
void | SetAutoUnspecified (bool enable=true)
| Set if user can change the property's value to unspecified by modifying the value of the editor control (usually by clearing it).
void | SetBackgroundColour (const wxColour &colour, int flags=wxPG_RECURSE)
| Sets property's background colour.
void | SetEditor (const wxPGEditor *editor)
| Sets editor for a property.
void | SetEditor (const wxString &editorName)
| Sets editor for a property, by editor name.
void | SetCell (int column, const wxPGCell &cell)
| Sets cell information for given column.
bool | SetChoices (wxPGChoices &choices)
| Sets new set of choices for the property.
void | SetClientData (void *clientData)
| Sets client data (void*) of a property.
void | SetClientObject (wxClientData *clientObject)
| Returns client object of a property.
void | SetChoiceSelection (int newValue)
| Sets selected choice and changes property value.
void | SetDefaultValue (wxVariant &value)
| Set default value of a property.
void | SetFlagRecursively (wxPGPropertyFlags flag, bool set)
| Sets or clears given property flag, recursively.
void | SetHelpString (const wxString &helpString)
| Sets property's help string, which is shown, for example, in wxPropertyGridManager's description text box.
void | SetLabel (const wxString &label)
| Sets property's label.
bool | SetMaxLength (int maxLen)
| Set max length of text in text editor.
void | SetModifiedStatus (bool modified)
| Sets property's "is it modified?" flag.
void | SetName (const wxString &newName)
| Sets new (base) name for property.
void | SetParentalType (int flag)
| Changes what sort of parent this property is for its children.
void | SetTextColour (const wxColour &colour, int flags=wxPG_RECURSE)
| Sets property's text colour.
void | SetValidator (const wxValidator &validator)
| Sets wxValidator for a property.
void | SetValue (wxVariant value, wxVariant *pList=NULL, int flags=wxPG_SETVAL_REFRESH_EDITOR)
| Call this to set value of the property.
void | SetValueImage (wxBitmap &bmp)
| Set wxBitmap in front of the value.
void | SetValueInEvent (wxVariant value) const
| Call this function in OnEvent(), OnButtonClick() etc.
void | SetValueToUnspecified ()
| Sets property's value to unspecified (ie.
void | SetWasModified (bool set=true)
| Call with false in OnSetValue() to cancel value changes after all (ie.
wxPGProperty * | UpdateParentValues ()
| Updates composed values of parent non-category properties, recursively.
bool | UsesAutoUnspecified () const
| Returns true if containing grid uses wxPG_EX_AUTO_UNSPECIFIED_VALUES.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Protected Member Functions
void | Empty ()
| Deletes all child properties.
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.

## Additional Inherited Members
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Member Typedef Documentation

typedef wxUint32 wxPGProperty::FlagType

## Constructor & Destructor Documentation

wxPGProperty::wxPGProperty | ( |  | ) |

Default constructor.

wxPGProperty::wxPGProperty | ( | const wxString & | label,
|  | const wxString & | name
| ) |  |

Constructor.

Non-abstract property classes should have constructor of this style:

MyProperty( const wxString& label, const wxString& name, const T& value )
: wxPGProperty(label, name)
{
// Generally recommended way to set the initial value
// (as it should work in pretty much 100% of cases).
wxVariant variant;
variant << value;
SetValue(variant);
// If has private child properties then create them here.
// For example:
// AddPrivateChild( new wxStringProperty("Subprop 1",
// wxPG_LABEL,
// value.GetSubProp1()));
}

virtual wxPGProperty::~wxPGProperty | ( |  | ) |
| virtual

Virtual destructor.

It is customary for derived properties to implement this.

## Member Function Documentation

void wxPGProperty::AdaptListToValue | ( | wxVariant & | list,
|  | wxVariant * | value
| ) |  | const

Adapts list variant into proper value using consecutive ChildChanged() calls.

int wxPGProperty::AddChoice | ( | const wxString & | label,
|  | int | value = `wxPG_INVALID_VALUE`
| ) |  |

Append a new choice to property's list of choices.

Parameters

  label | Label for added choice.
  value | Value for new choice. Do not specify if you wish this to equal choice index.

Returns
  Index to added choice.

void wxPGProperty::AddPrivateChild | ( | wxPGProperty * | prop | ) |

Adds a private child property.

If you use this instead of wxPropertyGridInterface::Insert() or wxPropertyGridInterface::AppendIn(), then property's parental type will automatically be set up to wxPG_PROP_AGGREGATE. In other words, all properties of this property will become private.

wxPGProperty* wxPGProperty::AppendChild | ( | wxPGProperty * | childProperty | ) |

Use this member function to add independent (ie.

regular) children to a property.

Returns
  Appended childProperty.

Remarks
  wxPropertyGrid is not automatically refreshed by this function.

See Also
  InsertChild(), AddPrivateChild()

bool wxPGProperty::AreAllChildrenSpecified | ( | wxVariant * | pendingList = `NULL` | ) | const

Determines, recursively, if all children are not unspecified.

Parameters

  pendingList | Assumes members in this wxVariant list as pending replacement values.

bool wxPGProperty::AreChildrenComponents | ( |  | ) | const

Returns true if children of this property are component values (for instance, points size, face name, and is_underlined are component values of a font).

void wxPGProperty::ChangeFlag | ( | wxPGPropertyFlags | flag,
|  | bool | set
| ) |  |

Sets or clears given property flag.

Mainly for internal use.

Remarks
  Setting a property flag never has any side-effect, and is intended almost exclusively for internal use. So, for example, if you want to disable a property, call Enable(false) instead of setting wxPG_PROP_DISABLED flag.

See Also
  HasFlag(), GetFlags()

virtual wxVariant wxPGProperty::ChildChanged | ( | wxVariant & | thisValue,
|  | int | childIndex,
|  | wxVariant & | childValue
| ) |  | const
| virtual

Called after value of a child property has been altered.

Must return new value of the whole property (after any alterations warranted by child's new value).

Note that this function is usually called at the time that value of this property, or given child property, is still pending for change, and as such, result of GetValue() or m_value should not be relied on.

Sample pseudo-code implementation:

wxVariant MyProperty::ChildChanged( wxVariant& thisValue,
int childIndex,
wxVariant& childValue ) const
{
// Acquire reference to actual type of data stored in variant
// (TFromVariant only exists if wxPropertyGrid's wxVariant-macros
// were used to create the variant class).
T& data = TFromVariant(thisValue);
// Copy childValue into data.
switch ( childIndex )
{
case 0:
data.SetSubProp1( childvalue.GetLong() );
break;
case 1:
data.SetSubProp2( childvalue.GetString() );
break;
...
}
// Return altered data
return data;
}

Parameters

  thisValue | Value of this property. Changed value should be returned (in previous versions of wxPropertyGrid it was only necessary to write value back to this argument).
  childIndex | Index of child changed (you can use Item(childIndex) to get child property).
  childValue | (Pending) value of the child property.

Returns
  Modified value of the whole property.

void wxPGProperty::DeleteChildren | ( |  | ) |

Deletes children of the property.

void wxPGProperty::DeleteChoice | ( | int | index | ) |

Removes entry from property's wxPGChoices and editor control (if it is active).

If selected item is deleted, then the value is set to unspecified.

virtual wxVariant wxPGProperty::DoGetAttribute | ( | const wxString & | name | ) | const
| virtual

Returns value of an attribute.

Override if custom handling of attributes is needed.

Default implementation simply return NULL variant.

virtual const wxPGEditor* wxPGProperty::DoGetEditorClass | ( |  | ) | const
| virtual

Returns pointer to an instance of used editor.

virtual wxValidator* wxPGProperty::DoGetValidator | ( |  | ) | const
| virtual

Returns pointer to the wxValidator that should be used with the editor of this property (NULL for no validator).

Setting validator explicitly via SetPropertyValidator will override this.

In most situations, code like this should work well (macros are used to maintain one actual validator instance, so on the second call the function exits within the first macro):

wxValidator* wxMyPropertyClass::DoGetValidator () const
{
WX_PG_DOGETVALIDATOR_ENTRY()
wxMyValidator* validator = new wxMyValidator(...);
... prepare validator...
WX_PG_DOGETVALIDATOR_EXIT(validator)
}

Remarks
  You can get common filename validator by returning wxFileProperty::GetClassValidator(). wxDirProperty, for example, uses it.

virtual wxVariant wxPGProperty::DoGetValue | ( |  | ) | const
| virtual

Override this to return something else than m_value as the value.

virtual bool wxPGProperty::DoSetAttribute | ( | const wxString & | name,
|  | wxVariant & | value
| ) |  |
| virtual

Reimplement this member function to add special handling for attributes of this property.

Returns
  Return false to have the attribute automatically stored in m_attributes. Default implementation simply does that and nothing else.

Remarks
  To actually set property attribute values from the application, use wxPGProperty::SetAttribute() instead.

void wxPGProperty::Empty | ( |  | ) |
| protected

Deletes all child properties.

void wxPGProperty::Enable | ( | bool | enable = `true` | ) |

Enables or disables the property.

Disabled property usually appears as having grey text.

Parameters

  enable | If false, property is disabled instead.

See Also
  wxPropertyGridInterface::EnableProperty()

wxString wxPGProperty::GenerateComposedValue | ( |  | ) | const

Composes text from values of child properties.

wxVariant wxPGProperty::GetAttribute | ( | const wxString & | name | ) | const

Returns property attribute value, null variant if not found.

wxString wxPGProperty::GetAttribute | ( | const wxString & | name,
|  | const wxString & | defVal
| ) |  | const

Returns named attribute, as string, if found.

Otherwise defVal is returned.

double wxPGProperty::GetAttributeAsDouble | ( | const wxString & | name,
|  | double | defVal
| ) |  | const

Returns named attribute, as double, if found.

Otherwise defVal is returned.

long wxPGProperty::GetAttributeAsLong | ( | const wxString & | name,
|  | long | defVal
| ) |  | const

Returns named attribute, as long, if found.

Otherwise defVal is returned.

wxVariant wxPGProperty::GetAttributesAsList | ( |  | ) | const

Returns attributes as list wxVariant.

const wxString& wxPGProperty::GetBaseName | ( |  | ) | const

Returns property's base name (ie.

parent's name is not added in any case)

const wxPGCell& wxPGProperty::GetCell | ( | unsigned int | column | ) | const

Returns wxPGCell of given column.

Remarks
  const version of this member function returns 'default' wxPGCell object if the property itself didn't hold cell data.

wxPGCell& wxPGProperty::GetCell | ( | unsigned int | column | ) |

Returns wxPGCell of given column, creating one if necessary.

virtual wxPGCellRenderer* wxPGProperty::GetCellRenderer | ( | int | column | ) | const
| virtual

Returns used wxPGCellRenderer instance for given property column (label=0, value=1).

Default implementation returns editor's renderer for all columns.

unsigned int wxPGProperty::GetChildCount | ( |  | ) | const

Returns number of child properties.

int wxPGProperty::GetChildrenHeight | ( | int | lh,
|  | int | iMax = `-1`
| ) |  | const

Returns height of children, recursively, and by taking expanded/collapsed status into account.

Parameters

  lh | Line height. Pass result of GetGrid()->GetRowHeight() here.
  iMax | Only used (internally) when finding property y-positions.

const wxPGChoices& wxPGProperty::GetChoices | ( |  | ) | const

Returns read-only reference to property's list of choices.

virtual int wxPGProperty::GetChoiceSelection | ( |  | ) | const
| virtual

Returns which choice is currently selected.

Only applies to properties which have choices.

Needs to reimplemented in derived class if property value does not map directly to a choice. Integer as index, bool, and string usually do.

void* wxPGProperty::GetClientData | ( |  | ) | const

Returns client data (void*) of a property.

wxClientData* wxPGProperty::GetClientObject | ( |  | ) | const

Sets managed client object of a property.

const wxPGEditor* wxPGProperty::GetColumnEditor | ( | int | column | ) | const

Returns editor used for given column.

NULL for no editor.

wxVariant wxPGProperty::GetDefaultValue | ( |  | ) | const

Returns property's default value.

If property's value type is not a built-in one, and "DefaultValue" attribute is not defined, then this function usually returns Null variant.

wxString wxPGProperty::GetDisplayedString | ( |  | ) | const

Returns property's displayed text.

const wxPGEditor* wxPGProperty::GetEditorClass | ( |  | ) | const

Returns wxPGEditor that will be used and created when property becomes selected.

Returns more accurate value than DoGetEditorClass().

virtual wxPGEditorDialogAdapter* wxPGProperty::GetEditorDialog | ( |  | ) | const
| virtual

Returns instance of a new wxPGEditorDialogAdapter instance, which is used when user presses the (optional) button next to the editor control;.

Default implementation returns NULL (ie. no action is generated when button is pressed).

FlagType wxPGProperty::GetFlags | ( |  | ) | const

Returns property flags.

wxPropertyGrid* wxPGProperty::GetGrid | ( |  | ) | const

Returns property grid where property lies.

wxPropertyGrid* wxPGProperty::GetGridIfDisplayed | ( |  | ) | const

Returns owner wxPropertyGrid, but only if one is currently on a page displaying this property.

const wxString& wxPGProperty::GetHelpString | ( |  | ) | const

Returns property's help or description text.

See Also
  SetHelpString()

unsigned int wxPGProperty::GetIndexInParent | ( |  | ) | const

Returns position in parent's array.

const wxString& wxPGProperty::GetLabel | ( |  | ) | const

Returns property's label.

const wxPGProperty* wxPGProperty::GetLastVisibleSubItem | ( |  | ) | const

Returns last visible child property, recursively.

wxPGProperty* wxPGProperty::GetMainParent | ( |  | ) | const

Returns highest level non-category, non-root parent.

Useful when you have nested properties with children.

Remarks
  If immediate parent is root or category, this will return the property itself.

int wxPGProperty::GetMaxLength | ( |  | ) | const

Returns maximum allowed length of property's text value.

wxString wxPGProperty::GetName | ( |  | ) | const

Returns property's name with all (non-category, non-root) parents.

wxPGCell& wxPGProperty::GetOrCreateCell | ( | unsigned int | column | ) |

Returns wxPGCell of given column, creating one if necessary.

wxPGProperty* wxPGProperty::GetParent | ( |  | ) | const

Return parent of property.

wxPGProperty* wxPGProperty::GetPropertyByName | ( | const wxString & | name | ) | const

Returns (direct) child property with given name (or NULL if not found).

wxValidator* wxPGProperty::GetValidator | ( |  | ) | const

Gets assignable version of property's validator.

wxVariant wxPGProperty::GetValue | ( |  | ) | const

Returns property's value.

virtual wxString wxPGProperty::GetValueAsString | ( | int | argFlags = `0` | ) | const
| virtual

Returns text representation of property's value.

Parameters

  argFlags | If 0 (default value), then displayed string is returned. If wxPG_FULL_VALUE is set, returns complete, storable string value instead of displayable. If wxPG_EDITABLE_VALUE is set, returns string value that must be editable in textctrl. If wxPG_COMPOSITE_FRAGMENT is set, returns text that is appropriate to display as a part of string property's composite text representation.

Remarks
  In older versions, this function used to be overridden to convert property's value into a string representation. This function is now handled by ValueToString(), and overriding this function now will result in run-time assertion failure.

wxBitmap* wxPGProperty::GetValueImage | ( |  | ) | const

Returns bitmap that appears next to value text.

Only returns non-NULL bitmap if one was set with SetValueImage().

wxString wxPGProperty::GetValueType | ( |  | ) | const

Returns value type used by this property.

int wxPGProperty::GetY | ( |  | ) | const

Returns coordinate to the top y of the property.

Note that the position of scrollbars is not taken into account.

FlagType wxPGProperty::HasFlag | ( | wxPGPropertyFlags | flag | ) | const

Returns non-zero if property has given flag set.

See Also
  propgrid_propflags

bool wxPGProperty::HasVisibleChildren | ( |  | ) | const

Returns true if property has even one visible child.

bool wxPGProperty::Hide | ( | bool | hide,
|  | int | flags = `wxPG_RECURSE`
| ) |  |

Hides or reveals the property.

Parameters

  hide | true for hide, false for reveal.
  flags | By default changes are applied recursively. Set this parameter wxPG_DONT_RECURSE to prevent this.

int wxPGProperty::Index | ( | const wxPGProperty * | p | ) | const

Returns index of given child property.

wxNOT_FOUND if given property is not child of this.

wxPGProperty* wxPGProperty::InsertChild | ( | int | index,
|  | wxPGProperty * | childProperty
| ) |  |

Use this member function to add independent (ie.

regular) children to a property.

Returns
  Inserted childProperty.

Remarks
  wxPropertyGrid is not automatically refreshed by this function.

See Also
  AppendChild(), AddPrivateChild()

int wxPGProperty::InsertChoice | ( | const wxString & | label,
|  | int | index,
|  | int | value = `wxPG_INVALID_VALUE`
| ) |  |

Inserts a new choice to property's list of choices.

Parameters

  label | Text for new choice
  index | Insertion position. Use wxNOT_FOUND to append.
  value | Value for new choice. Do not specify if you wish this to equal choice index.

virtual bool wxPGProperty::IntToValue | ( | wxVariant & | variant,
|  | int | number,
|  | int | argFlags = `0`
| ) |  | const
| virtual

Converts integer (possibly a choice selection) into wxVariant value appropriate for this property.

Parameters

  variant | On function entry this is the old value (should not be wxNullVariant in normal cases). Translated value must be assigned back to it.
  number | Integer to be translated into variant.
  argFlags | If wxPG_FULL_VALUE is set, returns complete, storable value instead of displayable one.

Returns
  Returns true if resulting wxVariant value was different.

Remarks
  - If property is not supposed to use choice or spinctrl or other editor with int-based value, it is not necessary to implement this method.
  - Default implementation simply assign given int to m_value.
  - If property uses choice control, and displays a dialog on some choice items, then it is preferred to display that dialog in IntToValue instead of OnEvent.
  - You might want to take into account that m_value is Mull variant if property value is unspecified (which is usually only case if you explicitly enabled that sort behaviour).

bool wxPGProperty::IsCategory | ( |  | ) | const

Returns true if this property is actually a wxPropertyCategory.

bool wxPGProperty::IsEnabled | ( |  | ) | const

Returns true if property is enabled.

bool wxPGProperty::IsExpanded | ( |  | ) | const

Returns true if property has visible children.

bool wxPGProperty::IsRoot | ( |  | ) | const

Returns true if this property is actually a wxRootProperty.

bool wxPGProperty::IsSomeParent | ( | wxPGProperty * | candidateParent | ) | const

Returns true if candidateParent is some parent of this property.

bool wxPGProperty::IsTextEditable | ( |  | ) | const

Returns true if property has editable wxTextCtrl when selected.

Remarks
  Although disabled properties do not displayed editor, they still return true here as being disabled is considered a temporary condition (unlike being read-only or having limited editing enabled).

bool wxPGProperty::IsValueUnspecified | ( |  | ) | const

Returns true if property's value is considered unspecified.

This usually means that value is Null variant.

bool wxPGProperty::IsVisible | ( |  | ) | const

Returns true if all parents expanded.

wxPGProperty* wxPGProperty::Item | ( | unsigned int | i | ) | const

Returns child property at index i.

virtual void wxPGProperty::OnCustomPaint | ( | wxDC & | dc,
|  | const wxRect & | rect,
|  | wxPGPaintData & | paintdata
| ) |  |
| virtual

Override to paint an image in front of the property value text or drop-down list item (but only if wxPGProperty::OnMeasureImage is overridden as well).

If property's OnMeasureImage() returns size that has height != 0 but less than row height ( < 0 has special meanings), wxPropertyGrid calls this method to draw a custom image in a limited area in front of the editor control or value text/graphics, and if control has drop-down list, then the image is drawn there as well (even in the case OnMeasureImage() returned higher height than row height).

NOTE: Following applies when OnMeasureImage() returns a "flexible" height ( using wxPG_FLEXIBLE_SIZE(W,H) macro), which implies variable height items: If rect.x is < 0, then this is a measure item call, which means that dc is invalid and only thing that should be done is to set paintdata.m_drawnHeight to the height of the image of item at index paintdata.m_choiceItem. This call may be done even as often as once every drop-down popup show.

Parameters

  dc | wxDC to paint on.
  rect | Box reserved for custom graphics. Includes surrounding rectangle, if any. If x is < 0, then this is a measure item call (see above).
  paintdata | wxPGPaintData structure with much useful data about painted item. struct wxPGPaintData { // wxPropertyGrid. const wxPropertyGrid* m_parent; // Normally -1, otherwise index to drop-down list item that has to be drawn. int m_choiceItem; // Set to drawn width in OnCustomPaint (optional). int m_drawnWidth; // In a measure item call, set this to the height of item at m_choiceItem index int m_drawnHeight; };

Remarks
  - You can actually exceed rect width, but if you do so then paintdata.m_drawnWidth must be set to the full width drawn in pixels.
  - Due to technical reasons, rect's height will be default even if custom height was reported during measure call.
  - Brush is guaranteed to be default background colour. It has been already used to clear the background of area being painted. It can be modified.
  - Pen is guaranteed to be 1-wide 'black' (or whatever is the proper colour) pen for drawing framing rectangle. It can be changed as well.

See Also
  ValueToString()

virtual bool wxPGProperty::OnEvent | ( | wxPropertyGrid * | propgrid,
|  | wxWindow * | wnd_primary,
|  | wxEvent & | event
| ) |  |
| virtual

Events received by editor widgets are processed here.

Note that editor class usually processes most events. Some, such as button press events of TextCtrlAndButton class, can be handled here. Also, if custom handling for regular events is desired, then that can also be done (for example, wxSystemColourProperty custom handles `wxEVT_CHOICE` to display colour picker dialog when 'custom' selection is made).

If the event causes value to be changed, SetValueInEvent() should be called to set the new value.

The parameter event is the associated wxEvent.

Return values

  Should | return true if any changes in value should be reported.

Remarks
  - If property uses choice control, and displays a dialog on some choice items, then it is preferred to display that dialog in IntToValue instead of OnEvent.

virtual wxSize wxPGProperty::OnMeasureImage | ( | int | item = `-1` | ) | const
| virtual

Returns size of the custom painted image in front of property.

This method must be overridden to return non-default value if OnCustomPaint is to be called.

Parameters

  item | Normally -1, but can be an index to the property's list of items.

Remarks
  - Default behaviour is to return wxSize(0,0), which means no image.
  - Default image width or height is indicated with dimension -1.
  - You can also return wxPG_DEFAULT_IMAGE_SIZE which equals wxSize(-1, -1).

virtual void wxPGProperty::OnSetValue | ( |  | ) |
| virtual

This virtual function is called after m_value has been set.

Remarks
  - If m_value was set to Null variant (ie. unspecified value), OnSetValue() will not be called.
  - m_value may be of any variant type. Typically properties internally support only one variant type, and as such OnSetValue() provides a good opportunity to convert supported values into internal type.
  - Default implementation does nothing.

virtual void wxPGProperty::OnValidationFailure | ( | wxVariant & | pendingValue | ) |
| virtual

Called whenever validation has failed with given pending value.

Remarks
  If you implement this in your custom property class, please remember to call the baser implementation as well, since they may use it to revert property into pre-change state.

virtual void wxPGProperty::RefreshChildren | ( |  | ) |
| virtual

Refresh values of child properties.

Automatically called after value is set.

void wxPGProperty::RefreshEditor | ( |  | ) |

If property's editor is active, then update it's value.

void wxPGProperty::SetAttribute | ( | const wxString & | name,
|  | wxVariant | value
| ) |  |

Sets an attribute for this property.

Parameters

  name | Text identifier of attribute. See wxPropertyGrid Property Attribute Identifiers.
  value | Value of attribute.

Remarks
  Setting attribute's value to Null variant will simply remove it from property's set of attributes.

void wxPGProperty::SetAutoUnspecified | ( | bool | enable = `true` | ) |

Set if user can change the property's value to unspecified by modifying the value of the editor control (usually by clearing it).

Currently, this can work with following properties: wxIntProperty, wxUIntProperty, wxFloatProperty, wxEditEnumProperty.

Parameters

  enable | Whether to enable or disable this behaviour (it is disabled by default).

void wxPGProperty::SetBackgroundColour | ( | const wxColour & | colour,
|  | int | flags = `wxPG_RECURSE`
| ) |  |

Sets property's background colour.

Parameters

  colour | Background colour to use.
  flags | Default is wxPG_RECURSE which causes colour to be set recursively. Omit this flag to only set colour for the property in question and not any of its children.

void wxPGProperty::SetCell | ( | int | column,
|  | const wxPGCell & | cell
| ) |  |

Sets cell information for given column.

bool wxPGProperty::SetChoices | ( | wxPGChoices & | choices | ) |

Sets new set of choices for the property.

Remarks
  This operation deselects the property and clears its value.

void wxPGProperty::SetChoiceSelection | ( | int | newValue | ) |

Sets selected choice and changes property value.

Tries to retain value type, although currently if it is not string, then it is forced to integer.

void wxPGProperty::SetClientData | ( | void * | clientData | ) |

Sets client data (void*) of a property.

Remarks
  This untyped client data has to be deleted manually.

void wxPGProperty::SetClientObject | ( | wxClientData * | clientObject | ) |

Returns client object of a property.

void wxPGProperty::SetDefaultValue | ( | wxVariant & | value | ) |

Set default value of a property.

Synonymous to

SetAttribute("DefaultValue", value);

void wxPGProperty::SetEditor | ( | const wxPGEditor * | editor | ) |

Sets editor for a property.

Parameters

  editor | For builtin editors, use wxPGEditor_X, where X is builtin editor's name (TextCtrl, Choice, etc. see wxPGEditor documentation for full list).

For custom editors, use pointer you received from wxPropertyGrid::RegisterEditorClass().

void wxPGProperty::SetEditor | ( | const wxString & | editorName | ) |

Sets editor for a property, by editor name.

void wxPGProperty::SetFlagRecursively | ( | wxPGPropertyFlags | flag,
|  | bool | set
| ) |  |

Sets or clears given property flag, recursively.

This function is primarily intended for internal use.

See Also
  ChangeFlag()

void wxPGProperty::SetHelpString | ( | const wxString & | helpString | ) |

Sets property's help string, which is shown, for example, in wxPropertyGridManager's description text box.

void wxPGProperty::SetLabel | ( | const wxString & | label | ) |

Sets property's label.

Remarks
  Properties under same parent may have same labels. However, property names must still remain unique.

bool wxPGProperty::SetMaxLength | ( | int | maxLen | ) |

Set max length of text in text editor.

void wxPGProperty::SetModifiedStatus | ( | bool | modified | ) |

Sets property's "is it modified?" flag.

Affects children recursively.

void wxPGProperty::SetName | ( | const wxString & | newName | ) |

Sets new (base) name for property.

void wxPGProperty::SetParentalType | ( | int | flag | ) |

Changes what sort of parent this property is for its children.

Parameters

  flag | Use one of the following values: wxPG_PROP_MISC_PARENT (for generic parents), wxPG_PROP_CATEGORY (for categories), or wxPG_PROP_AGGREGATE (for derived property classes with private children).

Remarks
  You generally do not need to call this function.

void wxPGProperty::SetTextColour | ( | const wxColour & | colour,
|  | int | flags = `wxPG_RECURSE`
| ) |  |

Sets property's text colour.

Parameters

  colour | Text colour to use.
  flags | Default is wxPG_RECURSE which causes colour to be set recursively. Omit this flag to only set colour for the property in question and not any of its children.

void wxPGProperty::SetValidator | ( | const wxValidator & | validator | ) |

Sets wxValidator for a property.

void wxPGProperty::SetValue | ( | wxVariant | value,
|  | wxVariant * | pList = `NULL`,
|  | int | flags = `wxPG_SETVAL_REFRESH_EDITOR`
| ) |  |

Call this to set value of the property.

Unlike methods in wxPropertyGrid, this does not automatically update the display.

Remarks
  Use wxPropertyGrid::ChangePropertyValue() instead if you need to run through validation process and send property change event.

If you need to change property value in event, based on user input, use SetValueInEvent() instead.

Parameters

  value | The value to set.
  pList | Pointer to list variant that contains child values. Used to indicate which children should be marked as modified. Usually you just use NULL.
  flags | wxPG_SETVAL_REFRESH_EDITOR is set by default, to refresh editor and redraw properties.

bool wxPGProperty::SetValueFromInt | ( | long | value,
|  | int | flags = `0`
| ) |  |

Converts integer to a value, and if successful, calls SetValue() on it.

Default behaviour is to do nothing.

Parameters

  value | Int to get the value from.
  flags | If has wxPG_FULL_VALUE, then the value given is a actual value and not an index.

Returns
  true if value was changed.

bool wxPGProperty::SetValueFromString | ( | const wxString & | text,
|  | int | flags = `0`
| ) |  |

Converts string to a value, and if successful, calls SetValue() on it.

Default behaviour is to do nothing.

Parameters

  text | String to get the value from.
  flags |

Todo:
  docme

Returns
  true if value was changed.

void wxPGProperty::SetValueImage | ( | wxBitmap & | bmp | ) |

Set wxBitmap in front of the value.

This bitmap may be ignored by custom cell renderers.

void wxPGProperty::SetValueInEvent | ( | wxVariant | value | ) | const

Call this function in OnEvent(), OnButtonClick() etc.

to change the property value based on user input.

Remarks
  This method is const since it doesn't actually modify value, but posts given variant as pending value, stored in wxPropertyGrid.

void wxPGProperty::SetValueToUnspecified | ( |  | ) |

Sets property's value to unspecified (ie.

Null variant).

void wxPGProperty::SetWasModified | ( | bool | set = `true` | ) |

Call with false in OnSetValue() to cancel value changes after all (ie.

cancel true returned by StringToValue() or IntToValue()).

virtual bool wxPGProperty::StringToValue | ( | wxVariant & | variant,
|  | const wxString & | text,
|  | int | argFlags = `0`
| ) |  | const
| virtual

Converts text into wxVariant value appropriate for this property.

Parameters

  variant | On function entry this is the old value (should not be wxNullVariant in normal cases). Translated value must be assigned back to it.
  text | Text to be translated into variant.
  argFlags | If wxPG_FULL_VALUE is set, returns complete, storable value instead of displayable one (they may be different). If wxPG_COMPOSITE_FRAGMENT is set, text is interpreted as a part of composite property string value (as generated by ValueToString() called with this same flag).

Returns
  Returns true if resulting wxVariant value was different.

Remarks
  Default implementation converts semicolon delimited tokens into child values. Only works for properties with children.

You might want to take into account that m_value is Null variant if property value is unspecified (which is usually only case if you explicitly enabled that sort behaviour).

wxPGProperty* wxPGProperty::UpdateParentValues | ( |  | ) |

Updates composed values of parent non-category properties, recursively.

Returns topmost property updated.

bool wxPGProperty::UsesAutoUnspecified | ( |  | ) | const

Returns true if containing grid uses wxPG_EX_AUTO_UNSPECIFIED_VALUES.

virtual bool wxPGProperty::ValidateValue | ( | wxVariant & | value,
|  | wxPGValidationInfo & | validationInfo
| ) |  | const
| virtual

Implement this function in derived class to check the value.

Return true if it is ok. Returning false prevents property change events from occurring.

Remarks
  - Default implementation always returns true.

virtual wxString wxPGProperty::ValueToString | ( | wxVariant & | value,
|  | int | argFlags = `0`
| ) |  | const
| virtual

Converts property value into a text representation.

Parameters

  value | Value to be converted.
  argFlags | If 0 (default value), then displayed string is returned. If wxPG_FULL_VALUE is set, returns complete, storable string value instead of displayable. If wxPG_EDITABLE_VALUE is set, returns string value that must be editable in textctrl. If wxPG_COMPOSITE_FRAGMENT is set, returns text that is appropriate to display as a part of string property's composite text representation.

Remarks
  Default implementation calls GenerateComposedValue().

wxPGProperty::wxDEPRECATED | ( | void | AddChildwxPGProperty *prop | ) |

Adds a private child property.

Deprecated:
  Use AddPrivateChild() instead.

See Also
  AddPrivateChild()

wxPGProperty::wxDEPRECATED | ( | wxString GetValueString(int argFlags=0) | const | ) |

Synonymous to GetValueAsString().

Deprecated:
  Use GetValueAsString() instead.

See Also
  GetValueAsString()